<?
include("bootstrap.php");



$module = isset($argv[1]) ? $argv[1] : "";
$ext = "";
$ext = isset($argv[1]) ? '.' . $argv[1] : '';
$ext .= isset($argv[2]) ? '.' . $argv[2] : '';
$ext .= '.lck';

define('LOCKFILE', $_AVOS['config']['site']['cronLockFile'] . $ext);

\Avos\Database\disableCache();
\Avos\Cron\debugModule($module);

if (file_exists(LOCKFILE)) {
	$pid = (int)file_get_contents(LOCKFILE);
	
	if ($pid > 0 && posix_kill($pid, 0) == true) {
		// script still running
		exit;
	}

	/*
	if (time() - filemtime(LOCKFILE) > 7200) {
		\Avos\Cron\debug("cron lockfile is older than 60 minutes so removing");
		unlink(LOCKFILE);
	}
	else {
		if (isset($argv[2])) {
			\Avos\Cron\debugModule($argv[2]);
		}
		\Avos\Cron\debug("cron aborting as an instance is already running");
		exit;
	}
	 */
}

file_put_contents(LOCKFILE, getmypid());
#\Avos\Cron\debug("cron starting");

//
// define what sites to work with
//

$sites = array();

foreach (array('BongaCams', 'Chaturbate', 'Flirt4Free', 'LiveJasmin', 'SoulCams', 'StripChat', 'Streamray', 'Streamate', 'CamSoda', 'Cherry', 'ImLive', 'xCams', 'Cam4', 'xLove', 'MyFreeCams', 'Amateur', 'FlirtBack') as $s) {
	if (isset($_AVOS['config']['webcams'][$s])) {
		$sites[] = $s;
		require(LIB . "Sites/" . $s . ".php"); 
		#\Avos\Cron\debug("configured [$s]");
	}
}

// 
// command line
//

if ($argc > 1) {

	//system($_AVOS['config']['tools']['touch'] . ' ' . LOCKFILE);

	$start = time();

	switch ($argv[1]) {

		//
		// iterate round each site updating models status
		//

				//

				case 'status':

					if (AVOS_DB_NAME != AVOS_DB_CAMS) {
						\Avos\Cron\debug("unable to run on satellite site");
					}
					else {
						if (isset($argv[2])) {
							\Avos\Cron\debugModule($argv[2]);
							\Avos\Cron\online_status_update($argv[2]);
						}
						else {
							foreach ($sites as $site) {
								\Avos\Cron\debugModule($site);
								\Avos\Cron\online_status_update($site);
							}
		
							\Avos\Cron\debugModule($module);
						}
					}
		
					break;

					case 'scrape':

						if (AVOS_DB_NAME != AVOS_DB_CAMS) {
							\Avos\Cron\debug("unable to run on satellite site");
						}
						else {
							$num = !empty($argv[2]) ? $argv[2] : 200;
							$min = !empty($argv[3]) ? $argv[3] : 15;
							$max = !empty($argv[4]) ? $argv[4] : 30;
							\Sites\Chaturbate\scrape_models($num, $min, $max);
							\Sites\CamSoda\scrape_models($num, $min, $max);
						}
			
						break;
			


			case 'scrapeapi':
				if  (AVOS_DB_NAME != AVOS_DB_CAMS) {
					\Avos\Cron\debug("unable to run on satellite site");
				} else {
					// Add the debug module statement before or after running the Chaturbate cron
					\Avos\Cron\debugModule($module);
					\Sites\Chaturbate\runChaturbateDataUpdateCron();
				}
				break; 
			




		//
		// download photos
		//

		case 'photos':
			foreach ($sites as $site) {
				\Avos\Cron\debugModule($site);
				$site_short = call_user_func('\\Sites\\' . $site . '\\get_shortname');
				\Avos\Cron\download_photos($site, $site_short);
			}
            \Avos\Cron\debugModule('photos');
			break;



		//
        // popular page
        //

		case 'popular':
            \Avos\Cron\cache_popular();
            \Avos\Cron\debugModule('trending');
            \Avos\Cron\cache_trending();
            \Avos\Cron\debugModule('updates');
            \Avos\Cron\cache_models_updates();
            break;



			
		//
        // photos_site
        //
			case 'photos_site':
				// Check if we are on the correct database
				if  (AVOS_DB_NAME != AVOS_DB_CAMS) {
					\Avos\Cron\debug("unable to run on satellite site");
				} else {
					// Convert the site names in the $sites array to lowercase
					$sites_lowercase = array_map('strtolower', $sites);
			
					// Check if a specific site name is provided in the command line arguments
					if (isset($argv[2])) {
						$specific_site = strtolower($argv[2]); // Convert the user-provided site name to lowercase
						
						// Ensure the site is valid
						if (in_array($specific_site, $sites_lowercase)) {
							// Find the original site name in the $sites array
							$site_index = array_search($specific_site, $sites_lowercase);
							$site = $sites[$site_index]; // Get the original site name
			
							\Avos\Cron\debugModule($site);
							$site_short = call_user_func('\\Sites\\' . $site . '\\get_shortname');
							\Avos\Cron\download_photos($site, $site_short);
						} else {
							// Handle invalid site name
							\Avos\Cron\debug("Error: The specified site '$specific_site' is not recognized.");
						}
					} else {
						// If no specific site is provided, iterate over all sites
						foreach ($sites as $site) {
							\Avos\Cron\debugModule($site);
							$site_short = call_user_func('\\Sites\\' . $site . '\\get_shortname');
							\Avos\Cron\download_photos($site, $site_short);
						}
						\Avos\Cron\debugModule('photos');
					}
				}
				break;
			


		//
		// process status updates to the daily and monthly tables and archive models
		//
		case 'stats':
			\Avos\Cron\debugModule($module);
			if (AVOS_DB_NAME != AVOS_DB_CAMS) {
				\Avos\Cron\debug("unable to run on satellite site");
			}
			else {
				\Avos\Cron\process_history();
				\Avos\Cron\archive_models();
			}
			break;

		//
		// move models to webcamsArchive table if not recently online
		//
		case 'logs':
			\Avos\Cron\trimLogs();
            \Avos\Cron\expireRequestsLog();
			break;
			
		//
		// purge stats or move to sqlite
		//

		case 'purge':
			if (AVOS_DB_NAME != AVOS_DB_CAMS) {
				\Avos\Cron\debug("unable to run on satellite site");
			}
			else {
				\Avos\Cron\purge();
			}
			break;

		case 'purgemonthly':
			if (AVOS_DB_NAME != AVOS_DB_CAMS) {
				\Avos\Cron\debug("unable to run on satellite site");
			}
			else {
				\Avos\Cron\purge('monthly');
                \Avos\Cron\debugModule('purgemodels');
				\Avos\Cron\purgeModels();
			}
			break;

		case 'purgehistory':
			if (AVOS_DB_NAME != AVOS_DB_CAMS) {
				\Avos\Cron\debug("unable to run on satellite site");
			}
			else {
				\Avos\Cron\purgeHistory();
			}
			break;

		case 'purgemodels':
			if (AVOS_DB_NAME != AVOS_DB_CAMS) {
				\Avos\Cron\debug("unable to run on satellite site");
			}
			else {
				\Avos\Cron\purgeModels();
			}
			break;

		//
		// transcode or publish videos and photos
		//

		case 'import':
			case 'publish':
			case 'actions':
				\Avos\Photos\cron($argv[1]);
				\Avos\Videos\cron($argv[1]);
				\Avos\Cron\debugModule($argv[1]);
				break;
	

		//
		// sync photos to a cdn
		//

		case 'cdnsync':
			\Avos\Cron\cdnSync();
			break;

		//
		// cache models to categories
		//
		case 'categories':
            \Avos\Cron\refreshCategories();
            \Avos\Cron\cache_popular_categories();

			if (AVOS_DB_NAME == AVOS_DB_CAMS) {
                \Avos\Cron\cache_site_totals();
            }
			break;


		//
		// cache all tags used by the webcams sites for the admin
		//
		case 'tags':
			\Avos\Cron\refreshSiteTags();
			break;


		//
		// cache videos to tags
		//

		case 'videostags':
			\Avos\Cron\refreshVideosTags();
			break;

		//
		// refresh sitemaps
		//

		case 'sitemaps':
			$index = isset($argv[2]) && $argv[2] == 'noindex' ? false : true;
			\Avos\Cron\refreshSitemap($index);
			break;



		//
		// load
		//

        case 'load':
			if (AVOS_DB_NAME != AVOS_DB_CAMS) {
				\Avos\Cron\debug("unable to run on satellite site");
            }
            else {
                \Avos\Cron\saveServerLoad();
            }
            break;




		//
		// backups
		//


		case 'backups':
			$now = isset($argv[2]) && $argv[2] == 'now' ? true : false;
			\Avos\Cron\backups($now);
			break;

		//
        // archive models
        //

        case 'archive':
			if (AVOS_DB_NAME != AVOS_DB_CAMS) {
				\Avos\Cron\debug("unable to run on satellite site");
            }
            else {
                \Avos\Cron\archive_models();
            }
            break;

        //
        // summary
        //

        case 'summary':
			if (AVOS_DB_NAME != AVOS_DB_CAMS) {
				\Avos\Cron\debug("unable to run on satellite site");
            }
            else {
                $redis = \Avos\Redis\handle();

                $limit = getConfig('webcams', 'statsCacheSummaryMax', 500);
                $last = \Avos\Redis\get('site', 0, 'summaryLastRun');

                $now = time();
                $cached = 0;
                $per = 0;

                $models = \Avos\Database\queryAssoc("SELECT id FROM webcams WHERE status != 'o' AND updatedOn > :last ORDER BY viewers DESC LIMIT :limit", ['last' => $last, 'limit' => $limit]);
                $nmodels = count($models);
                \Avos\Cron\debug("checking stats summary for $nmodels online models");

                foreach ($models as $i => $m) {
                    $chk = $redis->type($m['id'] . '/c');

                    if ($chk == \Redis::REDIS_NOT_FOUND) {
                        $s = \Avos\Redis\getStatsSummary($m['id']);
                        $cached++;

                        /*
                        if ((int)($i / $nmodels * 100) > $per) {
                            $per = (int)($i / $nmodels * 100);
                            \Avos\Cron\debug("re-cached $cached, $per% done");
                        }
                        */
                    }
                }

                \Avos\Cron\debug("cached $cached models stats summary");
                \Avos\Redis\set('site', 'summaryLastRun', $now);
            }
            break;



 		//
        // servers
        //

        case 'servers':

            $servers = getConfig('servers');
            $serversInfo = ['timestamp' => time(), 'elapsed' => 0, 'servers' => []];
            $sdbg = isset($argv[2]) ? 1 : 0;

			if (AVOS_DB_NAME != AVOS_DB_CAMS) {
				\Avos\Cron\debug("unable to run on satellite site");
            }

            else if (!count($servers)) {
				\Avos\Cron\debug("no [servers] block defined in config.ini");
            }
            else {
                foreach ($servers as $name => $spec) {
                    if (preg_match('!(.*):(.*)!', $spec, $c)) {
                        $domain = $c[1];
                        $rpckey = $c[2];

                        $hash = \Avos\Utils\rpcKeyHash($domain, $rpckey);
                        $url = "https://$domain/admin/rpc.php?k=$hash&a=sites";

                        if ($sdbg) \Avos\Cron\debug($url);
                        list($resp, $code, $elapsed) = \Avos\Utils\http_fetch($url);
                        if ($sdbg>1) echo "\n$resp\n\n";

                        if ($code != 200) {
                            \Avos\Cron\debug("$name: $domain: error, http code $code");
                        }
                        else {
                            //
                            // handle returned data
                            //

                            $resp = \Avos\Utils\object2array(json_decode($resp));

                            if (isset($resp['data'])) {
                                \Avos\Cron\debug("$name: $domain: found " . count($resp['data']) . " avos sites");

                                foreach ($resp['data'] as $site => $data) {
                                    if ($data['pageLoad'] > 2) {
                                        \Avos\Cron\debug("  $site slow $data[pageLoad]s");
                                    }
                                }

                                $serversInfo['servers'][$name] = $resp['data'];
                            }
                            else {
                                \Avos\Cron\debug("$name: $domain: error, no data returned");
                            }
                        }
                    }
                }

                $serversInfo['elapsed'] = time() - $serversInfo['timestamp'];
                \Avos\Redis\handle()->set('servers', $serversInfo);
            }


            break;


		//
		// users notifications
		//
		case 'users':
			\Avos\Users\cron();
			break;


			case 'update_robots':
			// Load the configuration
$config = parse_ini_file('config.ini', true);

// Determine the website to update (e.g., 'site1' or 'site2')
$websiteToUpdate = $_AVOS['config']['site']['url']; // You can dynamically change this based on your needs

// Get the path to the robots.txt file for the selected website
$robotsTxtPath =  $_AVOS['config']['site']['robots_txt_path'];

// Generate the content for robots.txt (as you did before)
$siteName = $_AVOS['config']['site']['site_update_robots'];
$robotsTxt = "User-agent: *\n";
$robotsTxt .= "Disallow:\n";
$robotsTxt .= "Allow:\n";
$robotsTxt .= "Sitemap: https://www.$siteName/sitemap.xml\n";

// Save or serve $robotsTxt as your robots.txt file content
file_put_contents($robotsTxtPath, $robotsTxt);

\Avos\Cron\debug("robots.txt has been updated for $websiteToUpdate.");

				
				break;
			


			

	}

    $elapsed = time() - $start;

    if ($elapsed > 0) {
        \Avos\Cron\debug("cron completed in $elapsed seconds\n");
    }
}
else {
	usage();
	exit;
}

function usage()
{
global $argv;

print "
$argv[0] [backups|logs|cdnsync|status|stats|servers|tags|purge|purgemonthly|import|actions|publish|categories|sitemaps|update_robots|photos|photos_site]


Available Commands:


System:
  backups:            - backup data to avos/backups/ folder
  logs:               - trim size of avos/logs/ files
  cdnsync:            - sync any files to a cdn
  sitemaps:           - create sitemaps. add noindex arg to not create the sitemap index (for wordpress plugin)
  servers:      	  - fetch info on all sites from servers defined in the [servers] block list of domainName:rpcKey
  update_robots       - Update the robots.txt (run on new website set)
 

Webcams:
  status               - Update models' status via feeds
  scrape               - Scrape extra data from HTML pages (chaturbate) Args: <num models> <min delay secs> <max delay secs>
  categories           - Cache data based on defined categories/tags
  stats                - Process models' stats information
  tags                 - Create a list of tags used by models, available in the admin
  purge:        	   - purges moveDailyStats models data and optionally moves from redis to the sqlite data store
  purgemonthly:        - purge data from moveStatusHistory, moveMonthlyStats, moveRanks months ago
  purgemodels:         - purge profile data if not online in moveAllAfterDays (run as part of purgemonthly)
  purgehistory:        - cleans out stale history data for models from redis

Videos and Photos:
  import               - Import and process new videos and zips of photo galleries from avos/incoming/
  actions              - Rename/delete files/folders as needed from admin actions
  publish              - Publish videos and photo galleries



";


 



}

unlink(LOCKFILE);
